use util::{FxHashMap as HashMap, FxHashSet as HashSet};
use std::sync::LazyLock as Lazy;

    /// ignore these as keywords
pub static KEYWORD_STOPWORDS: Lazy<HashSet<&'static str>> = Lazy::new(|| [
    "a", "we", "sys", "ffi", "placeholder", "app", "loops", "master", "library", "rs", "rust-lang",
    "accidentally", "additional", "adds", "against", "all", "allow", "allows", "really", "rustup-install",
    "already", "also", "alternative", "always", "an", "and", "any", "appropriate", "extra", "uses",
    "arbitrary", "are", "as", "at", "available", "based", "be", "because", "been", "implementations",
    "both", "but", "by", "can", "certain", "changes", "comes", "contains", "code", "core", "cost", "our",
    "crate", "crates.io", "current", "currently", "custom", "dependencies", "although", "generate-type",
    "dependency", "developers", "do", "don't", "e.g", "easily", "easy", "either", "implementation",
    "enables", "etc", "even", "every", "example", "examples", "features", "feel", "supported", "work",
    "files", "fast", "for", "from", "fully", "function", "get", "given", "had", "has", "per-second",
    "hacktoberfest", "keywords", "keyword", "categories", "slightly", "worry", "about", "efficiency",
    "have", "here", "if", "implementing", "implements", "implement", "implementer", "in", "includes",
    "including", "incurring", "installation", "interested", "into", "is", "it", "include", "optionally",
    "it's", "its", "itself", "just", "known", "large", "later", "accepts", "potential", "built-in",
    "license", "lightweight", "like", "made", "main", "make", "makes", "many", "theyre", "simplified",
    "may", "me", "means", "method", "minimal", "mit", "more", "mostly", "much", "whose", "high-performance",
    "need", "needed", "never", "new", "no", "noop", "not", "of", "on", "one", "options", "fine-grained",
    "parse-options", "parse-int", "char", "tools", "temp", "innovative", "related", "unfortunate",
    "empowering", "probably", "almost", "best-practices", "whereas", "folks", "unfortunately", "caveat",
    "only", "or", "other", "over", "plausible", "please", "possible", "program", "project", "simplify",
    "provides", "provide", "put", "readme", "release", "runs", "rust", "rust's", "same", "select",
    "see", "selected", "should", "similar", "simple", "simply", "since", "small", "so", "refreshingly",
    "some", "specific", "still", "stuff", "such", "take", "than", "that", "the", "analogue", "chosen",
    "their", "them", "then", "there", "therefore", "these", "they", "things", "something", "provided",
    "this", "those", "to", "todo", "too", "took", "travis", "two", "under", "us", "exact", "must",
    "usable", "use", "used", "useful", "using", "usage", "v1", "v2", "v3", "v4", "various", "might",
    "very", "via", "want", "way", "well", "we'll", "what", "when", "where", "which", "good", "index-html",
    "while", "will", "wip", "with", "without", "working", "works", "writing", "each", "branch-name",
    "written", "yet", "you", "your", "build status", "meritbadge", "common", "successfully", "needs",
    "respective-method", "time-ms", "returned", "requested", "out", "cause", "interesting", "know",
    "file was generated", "easy to use", "general-purpose", "fundamental", "affecting", "keep-track",
    "zlib-license", "full-featured", "pure-rust", "equivalent", "nearly", "upcoming", "my", "bring",
    "interacting", "managing", "libraries", "crates", "could", "actual", "invocations", "throughput",
    "improvement", "improving", "handling", "doesnt", "cannot", "cant", "neither", "effortlessly",
    "being", "unfinished", "potentially", "prevents", "relies", "returns", "takes", "unless", "support",
    "returned", "less-than", "than", "opens", "reimplementation", "functionality", "wonderful", "supports",
    "expected", "flavored", "between", "beautiful", "www", "active-development", "except", "after",
    "several", "simple-to-use", "apache-license", "apache2-license", "mit-license", "easy-to-use",
    "public-domain", "full-api", "convenient", "technologies", "making", "considered", "hassle", "published",
    "foundational", "ergonomic", "traditional", "directly", "incompatible", "newer", "absolutely",
    "understandable", "enabling", "unwraps", "techniques", "maintaining", "efficient", "async-web",
    "behave", "correspond", "giving", "primarily", "roughly", "powerful", "avoid", "development",
    "essential", "software-development", "prepend", "unreleased", "utilizing", "creating", "before",
    "questions", "answer", "commonly", "especially", "purpose", "independently", "formerly", "data-format",
    "often", "sometimes", "defining", "details-about", "system-software", "retrieves", "item", "type",
    "test-data", "usages", "actually", "distinguishes", "typically", "inside", "adjusted", "software",
    "corresponding", "providing", "specified", "elsewhere", "suppose", "zero-before", "none",
    "collectin", "quickly-generate", "least", "isnt", "isn-t", "each-input", "doesn", "closely", "developed",
    "gotten", "basically", "currently", "fewer", "taking", "otherwise", "else", "mysteriously", "focuses",
    "missing", "doing", "desirable", "passing", "does-anyone-read-these", "unresolved", "access-google",
    "mysterious", "adding", "designed", "efficiently", "according", "accordingly", "i-am", "json-web",
    "multiple-types", "detailed-information", "information-about", "entire", "entirely", "throughout",
    "decreasing", "prerequisites", "high-quality", "try-each", "async-fn", "performant", "index-type",
    "full-feature", "until", "essentially", "desired", "cargo-package", "blockingly", "unavailable",
    "flexibility", "doesn-t", "doesn't", "cant't", "haven't", "indicates", "applies", "poorly",
    "alternatively", "you're", "you'll", "enforcement", "preparation", "enhanced", "calculates",
    "official", "experiance", "agnostic", "manipulation", "supplied", "manually", "represents", "existing",
    "miscelaneuous", "alternate", "through", "importantly", "whole", "utils", "general-library",
    "unnecessary", "assumptions", "does", "straightforward", "json-yaml", "lightning-fast", "easier",
    "boolean-true", "one-to", "underlying", "rethinking", "favor", "result", "inspired", "around",
    "were", "previously", "enable", "open-source", "longer-maintained", "instead", "unopinionated", "api-api",
    "local-remote", "sync-async", "left-right", "messages-sent", "windows-linux", "yaml-json", "general",
    "event-event", "signed-unsigned", "cryptographically", "spawns", "rust-lang-rust", "language-support",
    "build-applications", "usual", "usually", "without", "vice-versa", "soon", "specifically", "within",
    "consistently", "purposes", "during", "improved", "manipulating", "enhancing", "involving", "outside",
    "utilize", "techniques", "offering", "paradigms", "representing", "achieve", "upon", "contributes","high-level",
    "wrapper", "inclusion", "data-handling", "comprehensive", "data-representation","blazing-performance",
    "data-format", "beta1","general-categories","general-programming","general-framework", "high-speed",
    "efficiency", "minimal-footprint", "resource-constrained", "leveraging",
    "functionalities", "streamline", "streamlined", "relevant", "meaningful", "others", "tailored", "rather", "analyzes",
    "particularly", "enhances", "manipulations", "sophisticated", "suitable", "likely", "most", "exists",
    ].iter().copied().collect());

    /// If one is present, ignore the others
pub static COND_STOPWORDS: Lazy<HashMap<&'static str, Option<&'static [&'static str]>>> = Lazy::new(|| [
        ("25519", Some(&["compression", "compressed"][..])),
        ("2d", Some(&["path", "paths"])), // not fs
        ("actix-web", Some(&["actix"])),
        ("actor", Some(&["mailbox"])),
        ("ad-hoc", Some(&["ad"])),
        ("advent-of-code", Some(&["aoc"])),
        ("allocator", Some(&["data-structures", "data-structure"])),
        ("animation", Some(&["kraken"])),
        ("annoy", Some(&["spotify"])),
        ("api-client", Some(&["api","async-client", "http-client", "http-request", "request-response", "http-request-response", "client-request"])),
        ("app-store", Some(&["store"])), // not storage
        ("arm", Some(&["no-std", "no_std", "feature:no_std"])), // embedded category
        ("async", Some(&["async-http", "async-web"])),
        ("async-client", Some(&["async-http", "user-agent"])),
        ("audio-stream", Some(&["output-stream", "io"])),
        ("audio-streaming", Some(&["media-streaming"])),
        ("aws", Some(&["cli", "ecs"])), // not game engine
        ("axum", Some(&["axum-framework", "axum-web"])),
        ("azure", Some(&["cli"])), // not game engine
        ("b-tree", Some(&["vector"])), // container vs math
        ("backup",  Some(&["up"])),
        ("batteries-included", Some(&["batteries", "included"])),
        ("bgp", Some(&["bmp"])),
        ("binary-data", Some(&["binary-representation", "byte-slice"])),
        ("binary-encoding", Some(&["binary-representation", "byte-buffer"])),
        ("binary-format", Some(&["binary-object", "binary-data"])),
        ("binary-representation", Some(&["representation"])),
        ("bindings", Some(&["system", "package", "bindgen"])),
        ("bioinformatics", Some(&["data-structures", "sqlite", "encode", "async", "plugin", "reader", "converter", "index", "framework", "server", "alignment"])),
        ("bit-set", Some(&["vector"])), // container vs math
        ("bit-vector", Some(&["vector"])), // container vs math
        ("bitcoin", Some(&["dex", "move", "usd", "json", "macro", "derive", "testing", "leveldb", "rocksdb","storage","store","db", "jsonrpc", "rpc", "http", "rgb", "day", "database", "key-value", "network", "wasm", "secp256k1", "client", "cli", "rpc", "websocket"])),
        ("bittorrent", Some(&["torrent"])),
        ("block-cipher", Some(&["operation", "feedback"])),
        ("blockchain", Some(&["dex", "usd", "oracle","cairo","rustc","compiler", "move", "smart", "decentralized", "vm", "db", "protocols", "language", "compiler", "cryptography", "postgres","postgresql", "leveldb", "rocksdb", "proc-macro", "macro", "derive", "graphql", "sdk", "json", "storage", "kv-db", "jsonrpc", "database", "rgb", "key-value", "network", "wasm", "nosql", "orm", "driver", "fun", "rpc", "client", "server", "p2p", "networking", "node", "websocket"])),
        ("boot", Some(&["time"])),
        ("bootloader", Some(&["image", "image-format"])),
        ("brainfuck", Some(&["text-processing"])),
        ("buffer", Some(&["window", "windows"])),
        ("build", Some(&["logic"])), // confuses categorization
        ("building-block",  Some(&["building", "block"])),
        ("byte-buffer", Some(&["byte-slice"])),
        ("bytecode", Some(&["binary-format", "binary-data"])),
        ("c64", Some(&["terminal", "core", "c"])),
        ("caching", Some(&["allocator"])),
        ("capnp", Some(&["cap-n", "n", "cap"])),
        ("cargo", Some(&["plugin"])),
        ("cargo-command", Some(&["subcommand", "cli"])),
        ("cargo-subcommand", Some(&["subcommand", "cli"])),
        ("chat", Some(&["matrix"])), // confuses categorization
        ("chatbot", Some(&["text-processing"])),
        ("chess", Some(&["bot"])),
        ("feistel", Some(&["networking"])),
        ("cidr", Some(&["class"])),
        ("cipher", Some(&["operation"])),
        ("cli", Some(&["exit-code"])),
        ("cli-tool", Some(&["cli"])),
        ("client", Some(&["client-request"])),
        ("client-side", Some(&["side"])),
        ("cloud", Some(&["google-api", "web-api"])),
        ("cloud-watch", Some(&["watch"])),
        ("codegen", Some(&["backend"])),
        ("coin", Some(&["dex", "db", "move", "proc-macro", "macro", "derive", "graphql", "sdk", "json", "storage", "kv-db", "jsonrpc", "database", "rgb", "key-value", "network", "wasm", "nosql", "orm", "driver", "fun", "rpc", "client", "server", "p2p", "networking", "node", "websocket"])),
        ("color-palette", Some(&["scheme"])),
        ("color-scheme", Some(&["scheme"])),
        ("colored-text", Some(&["colored"])),
        ("command-line-interface",  Some(&["terminal-interface"])),
        ("command-line-tool", Some(&["cli", "cli-tool", "command-line"])),
        ("command-line-utilities", Some(&["cli-tool", "cli"])),
        ("command-line-utility", Some(&["cli", "cli-tool", "command-line"])),
        ("compile-time", Some(&["time"])),
        ("compiler", Some(&["development-tools", "text", "text-processing", "parser"])),
        ("component", Some(&["components"])),
        ("compression", Some(&["cli"])),
        ("config", Some(&["text-processing"])),
        ("config-dir", Some(&["application-secret", "exit-code"])),
        ("connection-pool", Some(&["connection-manager"])),
        ("constant-time", Some(&["time"])),
        ("container", Some(&["filesystem", "file"])),
        ("container-image", Some(&["image", "image-format"])),
        ("contract", Some(&["wasm", "webassembly"])), // that's crypto-babble-nothingburger
        ("convolution", Some(&["kernel"])),
        ("cross-platform", Some(&["portable", "platform-independent", "platform-agnostic", "windows", "winsdk", "macos", "mac", "osx", "linux", "unix", "gnu"])),
        ("crypto", Some(&["no-std", "no_std"])), // it's a nice feature, but not defining one
        ("cryptocurrencies", Some(&["dex", "cairo", "move", "json", "jsonrpc", "database", "key-value", "network", "wasm", "nosql", "orm", "driver", "fun", "rpc", "client", "server", "p2p", "networking", "node", "websocket"])),
        ("cryptocurrency", Some(&["dex","oracle", "smart",  "move", "json", "decentralized", "jsonrpc", "database", "rgb", "key-value", "network", "wasm", "nosql", "orm", "driver", "fun", "rpc", "client", "server", "p2p", "networking", "node", "websocket", "twitch"])),
        ("cryptography", Some(&["crypto", "no-std", "no_std", "cli", "operation"])), // it's a nice feature, but not defining one
        ("css", Some(&["css-class", "class-name", "text-processing"])),
        ("css-color", Some(&["color-string"])),
        ("css-selectors", Some(&["css-class", "class-name"])),
        ("cuda", Some(&["nvidia"])), // confuses categorization
        ("curve25519", Some(&["compression", "compressed"])),
        ("data-file", Some(&["file"])),
        ("data-structure", Some(&["no-std", "no_std", "data"])), // it's a nice feature, but not defining one
        ("database", Some(&["embedded", "cli", "networking", "asynchronous", "text-processing", "data"])),
        ("database-migrations", Some(&["migration"])),
        ("database-schema", Some(&["schema"])),
        ("date-and-time", Some(&["compound", "astronomy"])),
        ("dbus", Some(&["bus"])),
        ("debugging", Some(&["snapshot"])),
        ("decompression", Some(&["cli"])),
        ("deep-learning", Some(&["math", "statistics"])),
        ("dependency-manager", Some(&["manager", "management"])),
        ("derive-error", Some(&["standard-error"])),
        ("dice", Some(&["rolling"])), // hash
        ("disassembler", Some(&["disassemble"])),
        ("disk-image", Some(&["image", "image-format"])),
        ("distributed", Some(&["filesystem", "file"])),
        ("distributed-computing", Some(&["robotics"])),
        ("docker-compose", Some(&["image", "image-format"])),
        ("docker-image", Some(&["image", "image-format"])),
        ("driver", Some(&["video"])),
        ("dsl", Some(&["template"])),
        ("e-mail", Some(&["cli"])),
        ("edge-computing", Some(&["robotics"])),
        ("edit-distance", Some(&["edit"])),
        ("editor", Some(&["terminal"])),
        ("elastic", Some(&["ecs", "text-processing"])), // not game engine
        ("elasticsearch", Some(&["ecs", "text-processing", "email", "elastic"])), // not game engine
        ("email", Some(&["decentralized", "cli"])),
        ("embeddable", Some(&["embeddable-scripting"])),
        ("embedded", Some(&["no-std", "no_std", "feature:no_std"])),
        ("embedded-database", Some(&["embedded"])),
        ("emulator", Some(&["6502", "core", "gpu", "color", "timer"])),
        ("enable", Some(&["disable"])),
        ("engine", Some(&["ffi"])),
        ("entity-component", Some(&["system"])), // not os
        ("entity-component-system", Some(&["system", "entity-component"])), // not os
        ("error", Some(&["color", "options"])),
        ("error-kind",  Some(&["kind"])),
        ("error-type", Some(&["standard-error"])),
        ("ethereum", Some(&["vm", "dex", "json", "codec", "decentralized","tests", "web3","jsonrpc", "database", "rgb", "key-value", "network", "wasm", "nosql", "orm", "driver", "fun", "rpc", "client", "server", "p2p", "networking", "node", "websocket", "trie", "http", "vm", "day", "rgb", "nosql", "eth", "log", "generic", "network", "wasm", "key-value", "orm", "client", "database", "secp256k1", "node", "websocket", "parity"])),
        ("ethernet", Some(&["eth"])),
        ("evm",  Some(&["vm"])),
        ("exchange", Some(&["twitch", "animation"])),
        ("execution", Some(&["time"])),
        ("exif", Some(&["container-image"])),
        ("exonum", Some(&["dex", "http", "day", "database", "key-value", "network", "wasm", "client"])),
        ("fantasy", Some(&["console"])),
        ("ffi", Some(&["api-bindings"])),
        ("file-format", Some(&["read-write"])),
        ("file-io", Some(&["read-write"])),
        ("file-metadata", Some(&["metadata-file"])),
        ("file-type", Some(&["parsing"])),
        ("finance", Some(&["cargo", "utility", "tools", "option", "command", "algorithm", "cli", "future", "futures"])),
        ("financial", Some(&["cargo", "utility", "tools", "option", "command", "algorithm", "cli"])),
        ("float", Some(&["math", "point"])),
        ("floating", Some(&["point"])),
        ("font", Some(&["text", "bitmap", "cli"])),
        ("forc", Some(&["plugin", "language", "compiler"])),
        ("framework", Some(&["game", "games"])),
        ("freedom", Some(&["speech"])),
        ("freetype", Some(&["text", "bitmap"])),
        ("fsm", Some(&["state-transition"])),
        ("fuel", Some(&["plugin", "language", "compiler"])),
        ("full-text-search", Some(&["retrieval", "text-search", "full-text"])),
        ("game", Some(&["simulator", "simulation", "cli", "video", "store", "data", "games", "wasm", "webassembly"])), // wasm games are nice, but should be in games category
        ("game-console", Some(&["console-game"])),
        ("game-dev", Some(&["game", "games", "cli", "tool"])),
        ("game-development", Some(&["game", "ffi"])),
        ("game-engine", Some(&["game", "ffi", "engine"][..])),
        ("game-engines", Some(&["game", "ffi", "engine"])),
        ("game-theory", Some(&["theory"])),
        ("gameboy", Some(&["boy"])),
        ("gamedev", Some(&["game", "games", "cli", "tool"])),
        ("garbage", Some(&["tracing"])),
        ("genetic-algorithm",  Some(&["ga"])),
        ("geo", Some(&["h3"])),
        ("geometric", Some(&["geo"])),
        ("geometry", Some(&["geo"])),
        ("git", Some(&["command-line", "terminal", "cli", "command-line-tool"])),
        ("golang", Some(&["go"])),
        ("google-cloud", Some(&["google-api"])),
        ("graphics", Some(&["text-processing", "usd"])),
        ("graphviz",  Some(&["dot-format"])),
        ("guessing", Some(&["testing"])),
        ("gui", Some(&["web-programming", "web"])),
        ("hd-wallet", Some(&["hd"])),
        ("hello", Some(&["testing"])),
        ("hello-world", Some(&["hello", "world"])),
        ("high-level", Some(&["level"])),
        ("holochain", Some(&["holo", "p2p", "networking"])),
        ("http", Some(&["request-response"])),
        ("http-client", Some(&["async-http", "async-io", "async-web", "client-request", "http-request"])),
        ("http-request-response", Some(&["request-response"])),
        ("http-server", Some(&["async-http", "async-web", "server-response", "client-server", "http-response"])),
        ("hyper-client", Some(&["hyper-http"])),
        ("hyper-server", Some(&["hyper-http"])),
        ("hyperium", Some(&["hyper-http"])),
        ("i18n", Some(&["text", "format", "message", "json", "ffi"])),
        ("image-format", Some(&["file-format"])),
        ("in-place", Some(&["place"])),
        ("information-retrieval", Some(&["information"])),
        ("interior-mutability", Some(&["interior"])),
        ("interpreter", Some(&["scheme-interpreter", "brainfuck-interpreter", "text", "text-processing", "parser"])),
        ("ios", Some(&["core"])),
        ("iot", Some(&["robotics", "rest"])),
        ("iter", Some(&["math"])),
        ("iterator", Some(&["window", "windows"])),
        ("javascript", Some(&["embedded", "no-std", "no_std", "feature:no_std", "ecma"])),
        ("javascript-engine", Some(&["engine", "javascript-parser"])),
        ("json-ld",  Some(&["ld"])),
        ("jwt", Some(&["json-web"])),
        ("kubernetes", Some(&["image", "image-format"])),
        ("l10n", Some(&["text", "format", "message", "json", "ffi"])),
        ("language", Some(&["server"])),
        ("language-server", Some(&["server", "language"])),
        ("learning", Some(&["network"])),
        ("led", Some(&["matrix"])), // confuses categorization
        ("lexer", Some(&["text-processing"])),
        ("lichess", Some(&["bot"])),
        ("life-time", Some(&["time"])),
        ("lifetime", Some(&["time"])),
        ("lint", Some(&["plugin"])),
        ("linter", Some(&["text-processing"])),
        ("linux", Some(&["windows", "winsdk", "macos", "mac", "osx"])),
        ("linux-kernel", Some(&["image", "image-format"])),
        ("llm", Some(&["language-model"])),
        ("lnp-bp", Some(&["dex", "move", "database", "rgb", "key-value", "network", "wasm", "nosql", "orm", "driver", "fun", "rpc", "client", "server", "p2p", "networking", "node", "websocket", "twitch"])),
        ("load-file", Some(&["load"])),
        ("low-poly", Some(&["poly"])),
        ("luhn", Some(&["alphabet"])),
        ("mac", Some(&["core"])),
        ("machine-learning", Some(&["math", "statistics"])),
        ("macos", Some(&["core"])),
        ("macro", Some(&["no-std", "no_std", "feature:no_std"])), // it's a nice feature, but not defining one
        ("macros", Some(&["no-std", "no_std", "feature:no_std"])),
        ("math", Some(&["embedded", "num", "text-processing", "symbolic", "algorithms", "algorithm", "utils"])), // confuses categorization
        ("mathematics", Some(&["num", "numeric", "symbolic", "algorithms", "algorithm", "utils"])), // confuses categorization
        ("matrix-bot", Some(&["matrix"])),
        ("matrix-chat", Some(&["matrix"])),
        ("matrix-org", Some(&["matrix"])),
        ("matrix-sdk", Some(&["matrix"])),
        ("medical", Some(&["image"])),
        ("memory", Some(&["os", "system", "storage", "address", "addresses"])), // too generic
        ("memory-management", Some(&["data-structures", "data-structure"])),
        ("memory-map", Some(&["map"])),   // it's mmap
        ("messaging", Some(&["matrix"])), // confuses categorization
        ("metadata", Some(&["metadata-file"])),
        ("mock", Some(&["macro", "derive", "plugin", "cargo"])),
        ("module", Some(&["core"])),
        ("monad", Some(&["options"])),
        ("multipart-form", Some(&["multipart"])),
        ("multipart-form-data", Some(&["multipart"])),
        ("music", Some(&["instruments", "instrument", "string"])), // telemetry…
        ("network", Some(&["interface"])),
        ("neural", Some(&["network"])),
        ("neural-networks", Some(&["math", "statistics", "network"])),
        ("nftables", Some(&["nft"])),
        ("nlp", Some(&["text-processing"])),
        ("no-color", Some(&["color"])),
        ("nzxt", Some(&["kraken"])),
        ("objective-c", Some(&["objective"])),
        ("oci", Some(&["image-format"])),
        ("oci-image", Some(&["image", "image-format"])),
        ("on-chain", None),
        ("onefetch", Some(&["fetch"])),
        ("opengl", Some(&["terminal", "console"])),
        ("option-pricing", Some(&["option"])),
        ("orm", Some(&["networking", "asynchronous"])),
        ("osx", Some(&["core"])),
        ("package-manager", Some(&["manager", "management"])),
        ("parity", Some(&["fun", "backend"])),
        ("parity-wasm", Some(&["wasm", "wasm-contract"])),
        ("parser", Some(&["no-std", "no_std", "game", "text-processing", "data-processing"])),
        ("parsing", Some(&["text-processing", "data-processing"])),
        ("pdf", Some(&["container-image"])),
        ("platform-independent", Some(&["portable", "platform-agnostic"])),
        ("polly", Some(&["poly"])),
        ("polygon", Some(&["poly"])),
        ("polygon-io", Some(&["polygon"])),
        ("polymorphism", Some(&["poly"])),
        ("polynomial", Some(&["poly"])),
        ("portable", Some(&["windows", "winsdk", "macos", "mac", "osx", "linux", "unix", "gnu"])),
        ("pre-processor", Some(&["processor"])),
        ("pretty-print", Some(&["color"])),
        ("pretty-printer", Some(&["color"])),
        ("primality", Some(&["testing"])),
        ("prime", Some(&["testing"])),
        ("programming-language", Some(&["language", "embeddable-scripting", "text-processing"])),
        ("progress-bar", Some(&["pb"])),
        ("projection",  Some(&["proj", "project"])),
        ("protocol", Some(&["game", "games", "container"])),
        ("publish", Some(&["testing"])),
        ("puzzle-solver", Some(&["solver"])), // not SAT
        ("pxr", Some(&["usd"])), // not dollar
        ("python-bindings",  Some(&["python"])),
        ("query-string", Some(&["query-parameters", "parameters"])), //db
        ("raspberry", Some(&["osx", "windows"])),
        ("raspberry-pi", Some(&["raspberry", "pi"])),
        ("ray-tracer", Some(&["tracing", "tracer"])),
        ("ray-tracing", Some(&["tracing", "tracer"])),
        ("rdbms", Some(&["networking", "asynchronous"])),
        ("real-time", Some(&["time"])),
        ("real-time-clock", Some(&["time-clock"])),
        ("realtime", Some(&["time"])),
        ("regex", Some(&["text", "linear", "time", "search"])),
        ("remote-procedure-call",  Some(&["remote-procedure", "call"])),
        ("rest", Some(&["api", "http-client"])),
        ("rest-api", Some(&["http-api", "web-api","xml", "json"])),
        ("rest-client", Some(&["http-client"])),
        ("result", Some(&["options"])),
        ("rgb", Some(&["matrix"])), // confuses categorization
        ("robotics", Some(&["localization"])),
        ("role-playing-game", Some(&["role-playing"])),
        ("rpc",  Some(&["remote-procedure", "call"])),
        ("rpg", Some(&["role-playing"])),
        ("rtc", Some(&["time-clock"])),
        ("ruma", Some(&["matrix"])),
        ("rust-analyzer", Some(&["analyzer"])),
        ("rustc",  Some(&["rust-c"])),
        ("safe", Some(&["network"])),
        ("schema-definition", Some(&["definition"])),
        ("scripting-language", Some(&["language"])),
        ("search", Some(&["text-processing"])),
        ("search-engine", Some(&["engine", "text-processing"])),
        ("secp256k1", Some(&["fun", "backend", "alloc", "ecc"])),
        ("serde", Some(&["serialization-deserialization", "serialisation-deserialisation"])),
        ("server", Some(&["files"])),
        ("server-framework", Some(&["framework"])),
        ("server-port", Some(&["host-port"])),
        ("server-sent-events", Some(&["server-sent"])),
        ("server-side", Some(&["side"])),
        ("sleep", Some(&["time"])),
        ("sliding", Some(&["window", "windows"])),
        ("smart-contracts", Some(&["dex", "oracle","wasm-contract","move","contract", "smart", "ink", "contract", "decentralized", "database", "proc-macro", "vm", "webassembly", "rgb", "key-value", "network", "wasm", "nosql", "orm", "driver", "fun", "rpc", "client", "server", "p2p", "networking", "node", "websocket", "twitch"])),
        ("social", Some(&["media"])),
        ("solana", Some(&["dex","oracle", "rustc","http", "day", "database", "key-value", "network", "wasm", "secp256k1", "performance", "client", "cli", "cryptographic", "gfx", "sdk"])),
        ("solver", Some(&["solve"])),
        ("sound", Some(&["3d", "windows"])),
        ("spa", Some(&["single-page"])),
        ("space-filling", Some(&["filling"])),
        ("space-filling-curve", Some(&["space-filling"])),
        ("specification-language", Some(&["language"])),
        ("sse",  Some(&["server-sent"])),
        ("sse", Some(&["server-sent"])),
        ("starknet", Some(&["dex","cairo", "oracle", "smart",  "move", "json", "decentralized", "jsonrpc", "database", "rgb", "key-value", "network", "wasm", "nosql", "orm", "driver", "fun", "rpc", "client", "server", "p2p", "networking", "node", "websocket", "twitch"])),
        ("state-machine", Some(&["state-transition"])),
        ("static-analysis", Some(&["static"])),
        ("static-site-generator", Some(&["site-generator", "generator"])),
        ("statically-typed",  Some(&["statically", "static", "typed", "typing"])),
        ("stderr", Some(&["standard-error"])),
        ("streaming-parser", Some(&["streaming"])),
        ("strong-typing",  Some(&["strongly", "typed", "typing"])),
        ("subcommand", Some(&["plugin", "cli"])),
        ("substrate", None),
        ("sway", Some(&["language", "compiler"])),
        ("swaywm", Some(&["fuel"])),
        ("symbolic", Some(&["text-processing"])),
        ("syn", Some(&["nom"])),
        ("synchronization-primitive", Some(&["primitive"])),
        ("system-wide", Some(&["wide"])),
        ("telegram-bot", Some(&["bot-api"])),
        ("telemetry", Some(&["text-processing", "config"])),
        ("template", Some(&["derive"])),
        ("template-engine", Some(&["text", "engine", "text-processing", "parser", "regex", "asynchronous"])),
        ("terminal", Some(&["math", "emulator"])),
        ("terminal-colors", Some(&["color-string"])),
        ("terminal-emulator", Some(&["math", "emulator"])),
        ("testing", Some(&["text-processing", "test"])),
        ("testnet", Some(&["testing", "test", "tests"])),
        ("tetcoin",  None),
        ("tex", Some(&["font"])),
        ("text-editor", Some(&["text-processing", "parser", "text-file"])),
        ("text-search", Some(&["text-processing"])),
        ("thread", Some(&["storage"])),
        ("thread-local", Some(&["mailbox"])),
        ("time", Some(&["compound", "astronomy"])),
        ("time-series", Some(&["time"])),
        ("timeout", Some(&["time"])),
        ("tinygo", Some(&["go"])),
        ("tokenizer", Some(&["text"])),
        ("tor", Some(&["circuit", "rpc-service"])),
        ("trading", Some(&["future", "futures"])),
        ("transactional-memory", Some(&["transactional", "transaction"])), // sql
        ("tui", Some(&["text-processing", "style", "terminal-size", "terminal-interface"])),
        ("twitch", Some(&["kraken"])),
        ("oodle", Some(&["kraken"])),
        ("type-inference",  Some(&["inference", "typed", "typing"])),
        ("unicode", Some(&["text"])),
        ("usb", Some(&["usd"])), // typo?
        ("usdt", Some(&["usd"])), // not dollar
        ("usdz", Some(&["usd"])), // not dollar
        ("user-agent", Some(&["ua"])),
        ("user-interface",  Some(&["interface"])),
        ("validation", Some(&["data-validation"])),
        ("variable-length", Some(&["variable"])),
        ("varint", Some(&["variable"])),
        ("vec", Some(&["vector"])), // container vs math
        ("verification", Some(&["formal"])),
        ("version-manager", Some(&["manager", "management"])),
        ("vice", Some(&["versa"])),
        ("video", Some(&["audio", "media-streaming", "cli", "video-file"])), // have to pick one…
        ("video-streaming", Some(&["media-streaming"])),
        ("vkontakte", Some(&["vk"])),
        ("vulkan", Some(&["vk", "cli"])),
        ("wallet", Some(&["dex", "hd","move",  "proc-macro", "macro", "derive", "graphql", "sdk", "json", "storage", "kv-db", "jsonrpc", "database", "rgb", "key-value", "network", "wasm", "nosql", "orm", "driver", "fun", "rpc", "client", "server", "p2p", "networking", "node", "websocket"])),
        ("wasm", Some(&["embedded", "javascript", "cli", "no-std", "no_std", "feature:no_std", "deploy"])),
        ("wasm-binary", Some(&["binary-format"])),
        ("wat", Some(&["text-processing"])),
        ("web", Some(&["windows", "macos", "mac", "osx", "linux"])),
        ("web-api", Some(&["api-bindings", "http-framework"])),
        ("web-framework", Some(&["framework", "web-server", "server-framework", "http-framework"])),
        ("web-server", Some(&["http-server", "async-http", "async-web", "server-response", "http-response", "client-server"])),
        ("web3", Some(&["dex", "decentralized","move", "tea", "json", "proc-macro", "jsonrpc", "database", "rgb", "key-value", "network", "wasm", "nosql", "orm", "driver", "fun", "rpc", "client", "server", "p2p", "networking", "node", "websocket", "twitch"])),
        ("webassembly", Some(&["embedded", "javascript", "no-std", "no_std", "feature:no_std"])),
        ("websocket", Some(&["http", "cli", "tokio", "client", "io", "network", "servo", "web"])), // there's a separate category for it
        ("winapi", Some(&["target", "windows", "gnu", "x86", "i686", "64", "pc"])),
        ("window-manager", Some(&["windows"])),
        ("windows", Some(&["gnu"])),
        ("wire-format", Some(&["wire"])),
        ("wit", Some(&["text-processing"])),
        ("write-ahead-log", Some(&["write-ahead"])),
        ("yaml", Some(&["text-processing"])),
        ("zero-copy", Some(&["copy"])),
        ("zkp", Some(&["cairo"])),

        // spam
        ("starknet", Some(&["cairo"])),
        ("zenoh", None),

        ("fluence", None),
        ("deprecated", None),
        ("abandoned", None),
        ("holochain", None),
        ("placeholder", None), // spam
        ("reserved", None), // spam
        ("reserved-name", None), // spam
        ("name-squatting", None), // spam
        ("parked", None), // spam
        ("squatting", None), // spam
        ("malware", None), // spam
        ("unfinished", None), // spam
    ].iter().copied().collect());

